<script setup lang="ts">
    import { computed, ref, Ref } from 'vue'
    import { serviceOfferIdInjectionKey } from '@/shared/constants'
    import SContentContainerFullView from '@/shared/components/SContentContainerFullView.vue'
    import { useMsal } from '@/plugins/msal/useMsal'
    import {
        isDefined,
        isUndefined,
        requiredInject,
    } from '@/shared/helpers/types'

    import SGeolocalisableItemListAndMap from '@/shared/item/components/SGeolocalisableItemListAndMap.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import SSideBar from '@/interventionServiceOffer/components/global/SSideBar.vue'
    import { z } from 'zod'
    import {
        stringToBooleanQueryTransformOption,
        useQueryParamBindingWithtransform,
    } from '@/shared/routing/composables/useQueryParamBinding'
    import { useSelectedItemListKey } from '@/interventionServiceOffer/composables/equipement/useSelectedItemListKey'
    import { useCommunFilterStore } from '@/interventionServiceOffer/stores/CommunFilterStore'
    import {
        SelectedItem,
        SelectedItemSchema,
        useItemLists,
    } from '@/interventionServiceOffer/composables/equipement/useItemLists'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import SInterventionsFilters from '@/interventionServiceOffer/components/intervention/SInterventionsFilters.vue'
    import { useEquipementRacine } from '@/interventionServiceOffer/composables/equipement/useEquipementRacine'
    import SInterventionDetails from '@/interventionServiceOffer/components/intervention/SInterventionDetails.vue'
    import SDemandeInterventionDetails from '@/interventionServiceOffer/components/demandeIntervention/SDemandeInterventionDetails.vue'
    import SEquipementDetails from '@/interventionServiceOffer/components/equipement/SEquipementDetails.vue'
    import { pluralForm } from '@/shared/helpers/strings'
    import SEquipementBreadcrumb from '@/interventionServiceOffer/components/equipement/SEquipementBreadcrumb.vue'
    import { InterventionServiceOfferItem } from '@/interventionServiceOffer/entities/item/InterventionServiceOfferItem'
    import SInterventionOrderBy from '@/interventionServiceOffer/components/intervention/SInterventionOrderBy.vue'
    import SDemandeInterventionsFilters from '@/interventionServiceOffer/components/demandeIntervention/SDemandeInterventionsFilters.vue'
    import { interventionServiceOfferInjectionKey } from '@/interventionServiceOffer/constants'
    import SSearchEntity from '@/interventionServiceOffer/components/searchEntity/SSearchEntity.vue'

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const interventionServiceOffer = requiredInject(
        interventionServiceOfferInjectionKey
    )
    const msal = useMsal()
    const userStore = useUserStore(msal)

    const communFiltersStore = useCommunFilterStore(
        'communFilters',
        serviceOfferId.value
    )
    const equipementRacine = useEquipementRacine(serviceOfferId)

    const { itemLists, selectedItem } = useItemLists(serviceOfferId) //mettre réactif si page change

    const selectedItemListKey = useSelectedItemListKey()
    const selectedItemlist = computed(() => {
        return itemLists.value[selectedItemListKey.value]
    })

    const expandFilterPanel: Ref<boolean> = ref(false)
    useQueryParamBindingWithtransform(
        'filter-panel',
        expandFilterPanel,
        z.string().optional(),
        stringToBooleanQueryTransformOption
    )

    useQueryParamBindingWithtransform(
        'selected-item',
        selectedItem,
        z.string().optional(),
        {
            queryReadTransform: (selectedItemString: string | undefined) => {
                return isUndefined(selectedItemString)
                    ? undefined
                    : SelectedItemSchema.parse(
                          /(?<type>interventions|équipements|demandes)-(?<id>.+)/.exec(
                              selectedItemString
                          )?.groups
                      )
            },
            queryWriteTransform: (queryParam: SelectedItem | undefined) => {
                return isDefined(queryParam)
                    ? `${queryParam.type}-${queryParam.id}`
                    : undefined
            },
        }
    )
</script>

<template>
    <s-contextual-navbar :page-title="interventionServiceOffer?.data?.title">
        <template #contextualButtons>
            <SSearchEntity
                @select-item="
                    (itemType, itemId) => {
                        selectedItem = {
                            type: itemType,
                            id: itemId,
                        }
                    }
                "
            />
            <v-btn
                icon="mdi-gauge"
                color="on-background"
                :to="{
                    name: 'intervention-service-offer/tableaux-de-mesures',
                    params: {
                        serviceOfferId,
                    },
                }"
            ></v-btn>
            <v-badge
                v-if="selectedItemlist.filters.hasChangedFilters()"
                data-cy="tune-badge"
                :offset-y="10"
                :offset-x="10"
                class="mr-3"
                color="error"
                :content="selectedItemlist.filters.getChangedFiltersQuantity()"
            >
                <v-btn
                    data-cy="btn-tune"
                    icon="mdi-tune"
                    color="on-background"
                    @click="expandFilterPanel = !expandFilterPanel"
                ></v-btn>
            </v-badge>
            <v-btn
                v-else
                data-cy="btn-tune"
                icon="mdi-tune"
                color="on-background"
                @click="expandFilterPanel = !expandFilterPanel"
            ></v-btn>
            <v-btn
                v-if="
                    userStore.currentUser.reachableRoles.includes(
                        `SERVICEOFFER_${serviceOfferId}_ROLE_SERVICEOFFER_ADMIN_LIST_USERS`
                    )
                "
                data-cy="btn-interventions-admin-user-list"
                icon="mdi-cog-outline"
                color="on-background"
                :to="{
                    name: 'InterventionServiceOffer/administration/utilisateurs/liste',
                    params: {
                        serviceOfferId,
                    },
                }"
            ></v-btn>
        </template>
    </s-contextual-navbar>
    <v-main>
        <s-content-container-full-view class="d-flex">
            <s-geolocalisable-item-list-and-map
                :is-loading="selectedItemlist.isValidating"
                :paginated-item-list="{
                    title: selectedItemlist.title,
                    items: selectedItemlist.items,
                    itemHeight: selectedItemlist.itemHeight,
                    loadMore: selectedItemlist.loadMore,
                    hasMore: selectedItemlist.hasMore,
                    isStale: selectedItemlist.isStale,
                    isLoading: selectedItemlist.isLoading,
                    reload: selectedItemlist.reLoad,
                }"
                :coordinates-item-list="selectedItemlist.allGeolocatedItems"
                :selected-item-id="selectedItem?.id"
                :item-pins="selectedItemlist.pins"
                @click-item="
                    (item: unknown) => {
                        selectedItem = {
                            type: (<InterventionServiceOfferItem>(
                                item
                            )).getItemType(),
                            id: (<InterventionServiceOfferItem>(
                                item
                            )).getItemId(),
                        }
                    }
                "
                @double-click-item="
                    (item: unknown) => {
                        if (
                            (<InterventionServiceOfferItem>(
                                item
                            )).getItemType() == 'équipements'
                        ) {
                            communFiltersStore.communFilters.filters[
                                'equipementRacine.id'
                            ] = (<InterventionServiceOfferItem>item).getItemId()
                            selectedItem = undefined
                            selectedItemListKey = 'équipements'
                        }
                    }
                "
                @close-detail-item="selectedItem = undefined"
            >
                <template #topOverlay>
                    <v-slide-group
                        style="margin-left: -8px"
                        :class="{
                            'fade-overflow-right': !$vuetify.display.mdAndUp,
                        }"
                        :show-arrows="$vuetify.display.mdAndUp"
                    >
                        <div
                            class="silab-leaflet-control mx-2"
                            style="width: fit-content"
                        >
                            <SEquipementBreadcrumb
                                :equipement="equipementRacine?.data"
                                @select-equipement-ancetre="
                                    (equipementId) => {
                                        communFiltersStore.communFilters.filters[
                                            'equipementRacine.id'
                                        ] = equipementId
                                    }
                                "
                                @select-dernier-equipement="
                                    (equipementId) => {
                                        selectedItem = {
                                            type: 'équipements',
                                            id: equipementId,
                                        }
                                    }
                                "
                            />
                        </div>
                    </v-slide-group>
                </template>
                <template
                    v-if="isDefined(selectedItem) && !$vuetify.display.mdAndUp"
                    #headers
                >
                    <div
                        class="w-100"
                        style="
                            display: flex;
                            justify-content: end;
                            margin-top: -25px;
                        "
                    >
                        <v-btn
                            class="ma-3"
                            density="comfortable"
                            size="small"
                            color="background"
                            icon="mdi-close"
                            @click="selectedItem = undefined"
                        ></v-btn>
                    </div>
                    <SInterventionDetails
                        v-if="selectedItem.type === 'interventions'"
                        :display-content="false"
                        :intervention-id="selectedItem.id"
                        @update-intervention="
                            itemLists.interventions.updateStaleness()
                        "
                        @solder-intervention="
                            itemLists.interventions.updateStaleness()
                        "
                    />
                    <SDemandeInterventionDetails
                        v-if="selectedItem.type === 'demandes'"
                        :display-content="false"
                        :demande-intervention-id="selectedItem.id"
                        @delete-demande-intervention="
                            () => {
                                selectedItem = undefined
                                itemLists.demandes.updateStaleness()
                            }
                        "
                        @update-demande-intervention="
                            itemLists.demandes.updateStaleness()
                        "
                    />
                    <SEquipementDetails
                        v-if="selectedItem.type === 'équipements'"
                        :display-content="false"
                        :equipement-id="selectedItem.id"
                        @select-equipement-racine="
                            (equipementId) => {
                                communFiltersStore.communFilters.filters[
                                    'equipementRacine.id'
                                ] = equipementId
                                selectedItem = undefined
                                selectedItemListKey = 'équipements'
                            }
                        "
                        @create-demande-intervention="
                            itemLists.demandes.updateStaleness()
                        "
                        @create-intervention="
                            (interventionId) => {
                                itemLists.interventions.updateStaleness()
                                selectedItem = {
                                    type: 'interventions',
                                    id: interventionId,
                                }
                            }
                        "
                    />
                </template>
                <template v-else #headers>
                    <v-tabs
                        v-model="selectedItemListKey"
                        background-color="primary"
                        align-tabs="center"
                        grow
                    >
                        <v-tab
                            v-for="(itemListForTab, itemType) in itemLists"
                            :key="itemType"
                            :value="itemType"
                            :rounded="false"
                            :data-cy="`tab-${itemType}`"
                        >
                            {{ itemListForTab.maxItems }}
                            {{
                                pluralForm(
                                    itemListForTab.title,
                                    isUndefined(itemListForTab.maxItems)
                                        ? 0
                                        : itemListForTab.maxItems
                                )
                            }}
                        </v-tab>
                    </v-tabs>
                </template>
                <template v-if="isDefined(selectedItem)" #item-details>
                    <SInterventionDetails
                        v-if="selectedItem.type === 'interventions'"
                        :display-header="$vuetify.display.mdAndUp"
                        :intervention-id="selectedItem.id"
                        @select-item="
                            (itemType, itemId) => {
                                selectedItem = {
                                    type: itemType,
                                    id: itemId,
                                }
                            }
                        "
                        @update-intervention="
                            itemLists.interventions.updateStaleness()
                        "
                        @solder-intervention="
                            itemLists.interventions.updateStaleness()
                        "
                    />
                    <SDemandeInterventionDetails
                        v-if="selectedItem.type === 'demandes'"
                        :display-header="$vuetify.display.mdAndUp"
                        :demande-intervention-id="selectedItem.id"
                        @delete-demande-intervention="
                            () => {
                                selectedItem = undefined
                                itemLists.demandes.updateStaleness()
                            }
                        "
                        @update-demande-intervention="
                            itemLists.demandes.updateStaleness()
                        "
                        @select-item="
                            (itemType, itemId) => {
                                selectedItem = {
                                    type: itemType,
                                    id: itemId,
                                }
                            }
                        "
                    />
                    <SEquipementDetails
                        v-if="selectedItem.type === 'équipements'"
                        :display-header="$vuetify.display.mdAndUp"
                        :equipement-id="selectedItem.id"
                        @select-item="
                            (itemType, itemId) => {
                                selectedItem = {
                                    type: itemType,
                                    id: itemId,
                                }
                            }
                        "
                        @select-equipement-racine="
                            (equipementId) => {
                                communFiltersStore.communFilters.filters[
                                    'equipementRacine.id'
                                ] = equipementId
                                selectedItem = undefined
                                selectedItemListKey = 'équipements'
                            }
                        "
                        @create-demande-intervention="
                            itemLists.demandes.updateStaleness()
                        "
                        @create-intervention="
                            (interventionId) => {
                                itemLists.interventions.updateStaleness()
                                selectedItem = {
                                    type: 'interventions',
                                    id: interventionId,
                                }
                            }
                        "
                    />
                </template>
            </s-geolocalisable-item-list-and-map>
            <s-side-bar
                v-model="expandFilterPanel"
                :is-mobile="!$vuetify.display.lgAndUp"
                class="flex-shrink-0"
                style="border-left: 1px solid #b8b9ba"
            >
                <p class="d-inline-flex flex-wrap">
                    <v-chip
                        v-if="selectedItemlist.filters.hasChangedFilters()"
                        data-cy="filters-chip"
                        color="secondary"
                        class="ma-2"
                        closable
                        rounded="true"
                        variant="outlined"
                        close-label="Vider les filtres"
                        @click:close="selectedItemlist.filters.resetFilters()"
                    >
                        <v-icon start icon="mdi-label"></v-icon>
                        Filtres appliqués
                    </v-chip>
                </p>

                <div v-if="selectedItemListKey === 'interventions'">
                    <s-interventions-filters
                        v-model="selectedItemlist.filters"
                    />
                    <s-intervention-order-by
                        v-if="isDefined(selectedItemlist.orderBy)"
                        v-model="selectedItemlist.orderBy"
                    />
                </div>

                <div v-if="selectedItemListKey === 'demandes'">
                    <s-demande-interventions-filters
                        v-model="selectedItemlist.filters"
                    />
                </div>

                <div v-if="selectedItemListKey === 'équipements'">
                    <p class="pa-8" style="max-width: 400px">
                        Pour le moment Siilab ne propose pas de filtres pour les
                        équipements.
                    </p>
                </div>
            </s-side-bar>
        </s-content-container-full-view>
    </v-main>
</template>

<style>
    html {
        overscroll-behavior: none;
    }
</style>
<style scoped lang="scss">
    @use '../../../shared/map/styles/style.scss';
    .fade-overflow-right {
        mask-image: linear-gradient(
            to right,
            black calc(100% - 15px),
            transparent
        );
    }
</style>
